<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'PaymentRQ' => '\\StructType\\PaymentRQ',
            'Action' => '\\StructType\\Action',
            'ServiceIndicator' => '\\StructType\\ServiceIndicator',
            'OrderDetail' => '\\StructType\\OrderDetail',
            'MsfAgencyFeeDetail' => '\\StructType\\MsfAgencyFeeDetail',
            'CustomerDetail' => '\\StructType\\CustomerDetail',
            'PaymentRS' => '\\StructType\\PaymentRS',
            'Result' => '\\StructType\\Result',
            'Results' => '\\StructType\\Results',
            'FOP' => '\\StructType\\FOP',
            'AccountValidationResult' => '\\StructType\\AccountValidationResult',
            'BalanceInquiryResult' => '\\StructType\\BalanceInquiryResult',
            'VerificationResult' => '\\StructType\\VerificationResult',
            'DCC_Result' => '\\StructType\\DCC_Result',
            'MCP_Result' => '\\StructType\\MCP_Result',
            'MCP_Offer' => '\\StructType\\MCP_Offer',
            'GetCardResult' => '\\StructType\\GetCardResult',
            'QueryDeferredPaymentResult' => '\\StructType\\QueryDeferredPaymentResult',
            'GetBINResult' => '\\StructType\\GetBINResult',
            'CaptureResult' => '\\StructType\\CaptureResult',
            'AccountDetail' => '\\StructType\\AccountDetail',
            'ListOfVouchers' => '\\StructType\\ListOfVouchers',
            'DeferredPaymentDetail' => '\\StructType\\DeferredPaymentDetail',
            'CardDetail' => '\\StructType\\CardDetail',
            'FraudRemarks' => '\\StructType\\FraudRemarks',
            'NotificationList' => '\\StructType\\NotificationList',
            'Notification' => '\\StructType\\Notification',
            'DBIItems' => '\\StructType\\DBIItems',
            'PassengerDetail' => '\\StructType\\PassengerDetail',
            'AccountDetailType' => '\\StructType\\AccountDetailType',
            'AddressType' => '\\StructType\\AddressType',
            'StateProv' => '\\StructType\\StateProv',
            'AuthenticationDetailType' => '\\StructType\\AuthenticationDetailType',
            'AuthorizationResultType' => '\\StructType\\AuthorizationResultType',
            'CardReaderResult' => '\\StructType\\CardReaderResult',
            'T3DS_Result' => '\\StructType\\T3DS_Result',
            'PIN_Result' => '\\StructType\\PIN_Result',
            'AuthResponseDetail' => '\\StructType\\AuthResponseDetail',
            'LocalCardDetail' => '\\StructType\\LocalCardDetail',
            'AdditionalApprovals' => '\\StructType\\AdditionalApprovals',
            'Approval' => '\\StructType\\Approval',
            'VoucherDetail' => '\\StructType\\VoucherDetail',
            'ListOfReferenceNbrs' => '\\StructType\\ListOfReferenceNbrs',
            'NetworkTokenDetail' => '\\StructType\\NetworkTokenDetail',
            'AccountValidationResultType' => '\\StructType\\AccountValidationResultType',
            'AVS_ResultType' => '\\StructType\\AVS_ResultType',
            'CancelAuthResultType' => '\\StructType\\CancelAuthResultType',
            'CarRentalType' => '\\StructType\\CarRentalType',
            'Pickup' => '\\StructType\\Pickup',
            'Return' => '\\StructType\\_Return',
            'Renter' => '\\StructType\\Renter',
            'ConfirmAuthResultType' => '\\StructType\\ConfirmAuthResultType',
            'ContactInfoType' => '\\StructType\\ContactInfoType',
            'CostType' => '\\StructType\\CostType',
            'CountryNameType' => '\\StructType\\CountryNameType',
            'CSC_ResultType' => '\\StructType\\CSC_ResultType',
            'CurrencyAmountType' => '\\StructType\\CurrencyAmountType',
            'DCCType' => '\\StructType\\DCCType',
            'MCPType' => '\\StructType\\MCPType',
            'DocumentType' => '\\StructType\\DocumentType',
            'EMD_CouponDetail' => '\\StructType\\EMD_CouponDetail',
            'FareBreakType' => '\\StructType\\FareBreakType',
            'FeeBreakType' => '\\StructType\\FeeBreakType',
            'FlightDetailType' => '\\StructType\\FlightDetailType',
            'DepartureInfo' => '\\StructType\\DepartureInfo',
            'ArrivalInfo' => '\\StructType\\ArrivalInfo',
            'FOP_FareBreakType' => '\\StructType\\FOP_FareBreakType',
            'FOPType' => '\\StructType\\FOPType',
            'FraudScreenResultType' => '\\StructType\\FraudScreenResultType',
            'GetCardResultType' => '\\StructType\\GetCardResultType',
            'GuestType' => '\\StructType\\GuestType',
            'HotelType' => '\\StructType\\HotelType',
            'IssuerNameType' => '\\StructType\\IssuerNameType',
            'MerchantDetailType' => '\\StructType\\MerchantDetailType',
            'MiscItemType' => '\\StructType\\MiscItemType',
            'NameValueType' => '\\StructType\\NameValueType',
            'PassengerDetailType' => '\\StructType\\PassengerDetailType',
            'Document' => '\\StructType\\Document',
            'PaymentCardType' => '\\StructType\\PaymentCardType',
            'T3DS' => '\\StructType\\T3DS',
            'CardReader' => '\\StructType\\CardReader',
            'CardHolderName' => '\\StructType\\CardHolderName',
            'Identifications' => '\\StructType\\Identifications',
            'CardIssuerName' => '\\StructType\\CardIssuerName',
            'VCL_Info' => '\\StructType\\VCL_Info',
            'VirtualCard' => '\\StructType\\VirtualCard',
            'PaymentDetailType' => '\\StructType\\PaymentDetailType',
            'PaymentCard' => '\\StructType\\PaymentCard',
            'AmountDetail' => '\\StructType\\AmountDetail',
            'AuthorizationResult' => '\\StructType\\AuthorizationResult',
            'CardUsageResult' => '\\StructType\\CardUsageResult',
            'RoutingDetail' => '\\StructType\\RoutingDetail',
            'InstallmentDetail' => '\\StructType\\InstallmentDetail',
            'VirtualPaymentDetail' => '\\StructType\\VirtualPaymentDetail',
            'PaymentInfoType' => '\\StructType\\PaymentInfoType',
            'PersonID_Type' => '\\StructType\\PersonID_Type',
            'Passport' => '\\StructType\\Passport',
            'Visa' => '\\StructType\\Visa',
            'Other' => '\\StructType\\Other',
            'PhoneType' => '\\StructType\\PhoneType',
            'POS_Type' => '\\StructType\\POS_Type',
            'BrowserDetail' => '\\StructType\\BrowserDetail',
            'HttpHeaders' => '\\StructType\\HttpHeaders',
            'HttpHeader' => '\\StructType\\HttpHeader',
            'ProductDetailType' => '\\StructType\\ProductDetailType',
            'ProviderInfoType' => '\\StructType\\ProviderInfoType',
            'RailJourneyType' => '\\StructType\\RailJourneyType',
            'Ticket' => '\\StructType\\Ticket',
            'RailType' => '\\StructType\\RailType',
            'RefundResultType' => '\\StructType\\RefundResultType',
            'CancelRefundResultType' => '\\StructType\\CancelRefundResultType',
            'RemarksType' => '\\StructType\\RemarksType',
            'ReturnURLsType' => '\\StructType\\ReturnURLsType',
            'RoomStayType' => '\\StructType\\RoomStayType',
            'StateProvType' => '\\StructType\\StateProvType',
            'StreetNmbrType' => '\\StructType\\StreetNmbrType',
            'SubBalanceType' => '\\StructType\\SubBalanceType',
            'SupplierMessagesType' => '\\StructType\\SupplierMessagesType',
            'TaxType' => '\\StructType\\TaxType',
            'TokenizationResultType' => '\\StructType\\TokenizationResultType',
            'TokensType' => '\\StructType\\TokensType',
            'Token' => '\\StructType\\Token',
            'TPA_ExtensionsType' => '\\StructType\\TPA_ExtensionsType',
            'VoucherType' => '\\StructType\\VoucherType',
            'RegisterAuthResultType' => '\\StructType\\RegisterAuthResultType',
            'AdditionalDetailType' => '\\StructType\\AdditionalDetailType',
            'Field' => '\\StructType\\Field',
            'LoyaltyMembershipDetailType' => '\\StructType\\LoyaltyMembershipDetailType',
            'ReferenceNbrType' => '\\StructType\\ReferenceNbrType',
            'T3DS_ResultType' => '\\StructType\\T3DS_ResultType',
            'ValidateAndQueryPaymentDetailResultType' => '\\StructType\\ValidateAndQueryPaymentDetailResultType',
            'RemarkLinesType' => '\\StructType\\RemarkLinesType',
            'GetDeploymentResultType' => '\\StructType\\GetDeploymentResultType',
            'CustomIdentifiersType' => '\\StructType\\CustomIdentifiersType',
            'CustomIdentifier' => '\\StructType\\CustomIdentifier',
            'UpdateDeploymentResultType' => '\\StructType\\UpdateDeploymentResultType',
            'GetCardActivityResultType' => '\\StructType\\GetCardActivityResultType',
            'CardActivityType' => '\\StructType\\CardActivityType',
            'T3DS_AuthenticationResultType' => '\\StructType\\T3DS_AuthenticationResultType',
            'SignatureType' => '\\StructType\\SignatureType',
            'SignatureValueType' => '\\StructType\\SignatureValueType',
            'SignedInfoType' => '\\StructType\\SignedInfoType',
            'CanonicalizationMethodType' => '\\StructType\\CanonicalizationMethodType',
            'SignatureMethodType' => '\\StructType\\SignatureMethodType',
            'ReferenceType' => '\\StructType\\ReferenceType',
            'TransformsType' => '\\StructType\\TransformsType',
            'TransformType' => '\\StructType\\TransformType',
            'DigestMethodType' => '\\StructType\\DigestMethodType',
            'KeyInfoType' => '\\StructType\\KeyInfoType',
            'KeyValueType' => '\\StructType\\KeyValueType',
            'RetrievalMethodType' => '\\StructType\\RetrievalMethodType',
            'X509DataType' => '\\StructType\\X509DataType',
            'X509IssuerSerialType' => '\\StructType\\X509IssuerSerialType',
            'PGPDataType' => '\\StructType\\PGPDataType',
            'SPKIDataType' => '\\StructType\\SPKIDataType',
            'ObjectType' => '\\StructType\\ObjectType',
            'ManifestType' => '\\StructType\\ManifestType',
            'SignaturePropertiesType' => '\\StructType\\SignaturePropertiesType',
            'SignaturePropertyType' => '\\StructType\\SignaturePropertyType',
            'DSAKeyValueType' => '\\StructType\\DSAKeyValueType',
            'RSAKeyValueType' => '\\StructType\\RSAKeyValueType',
            'Envelope' => '\\StructType\\Envelope',
            'Header' => '\\StructType\\Header',
            'Body' => '\\StructType\\Body',
            'Fault' => '\\StructType\\Fault',
            'detail' => '\\StructType\\Detail',
            'Manifest' => '\\StructType\\Manifest',
            'Reference' => '\\StructType\\Reference',
            'Schema' => '\\StructType\\Schema',
            'MessageHeader' => '\\StructType\\MessageHeader',
            'Service' => '\\StructType\\Service',
            'MessageData' => '\\StructType\\MessageData',
            'SyncReply' => '\\StructType\\SyncReply',
            'MessageOrder' => '\\StructType\\MessageOrder',
            'AckRequested' => '\\StructType\\AckRequested',
            'Acknowledgment' => '\\StructType\\Acknowledgment',
            'ErrorList' => '\\StructType\\ErrorList',
            'Error' => '\\StructType\\Error',
            'StatusResponse' => '\\StructType\\StatusResponse',
            'StatusRequest' => '\\StructType\\StatusRequest',
            'sequenceNumber.type' => '\\StructType\\SequenceNumber_type',
            'PartyId' => '\\StructType\\PartyId',
            'To' => '\\StructType\\To',
            'From' => '\\StructType\\From',
            'Description' => '\\StructType\\Description',
            'Security' => '\\StructType\\Security',
            'UsernameToken' => '\\StructType\\UsernameToken',
        );
    }
}
